CREATE TABLE TABLE1
(
  ID INTEGER NOT NULL,
  COL1 CHAR(25),
  COL2 CHAR(25),
  PRIMARY KEY (ID)
);

CREATE TABLE TABLE2
(
  ID INTEGER NOT NULL,
  TABLE1_ID INTEGER NOT NULL,
  COL1 CHAR(25),
  COL2 CHAR(25),
  PRIMARY KEY (ID),
  FOREIGN KEY (TABLE1_ID) REFERENCES TABLE1(ID)
);

CREATE TABLE TABLE3
(
  ID INTEGER NOT NULL,
  TABLE2_ID INTEGER NOT NULL,
  COL1 CHAR(25),
  COL2 CHAR(25),
  PRIMARY KEY (ID),
  FOREIGN KEY (TABLE2_ID) REFERENCES TABLE2(ID)
);

CREATE TABLE TABLE4
(
  ID INTEGER NOT NULL,
  TABLE3_ID INTEGER NOT NULL,
  COL1 CHAR(25),
  COL2 CHAR(25),
  PRIMARY KEY (ID),
  FOREIGN KEY (TABLE3_ID) REFERENCES TABLE3(ID)
);


CREATE TABLE TABLE5
(
  ID INTEGER NOT NULL,
  TABLE4_ID INTEGER NOT NULL,
  COL1 CHAR(25),
  COL2 CHAR(25),
  PRIMARY KEY (ID),
  FOREIGN KEY (TABLE4_ID) REFERENCES TABLE4(ID)
);

-- Make all COL1 significant columns
CREATE UNIQUE INDEX TABLE1_COL1_UNQ ON TABLE1 (COL1);
CREATE UNIQUE INDEX TABLE2_COL1_UNQ ON TABLE2 (COL1);
CREATE UNIQUE INDEX TABLE3_COL1_UNQ ON TABLE3 (COL1);
CREATE UNIQUE INDEX TABLE4_COL1_UNQ ON TABLE4 (COL1);
CREATE UNIQUE INDEX TABLE5_COL1_UNQ ON TABLE5 (COL1);
