SELECT
  DB_NAME() AS TABLE_CATALOG,
  SCHEMA_NAME(O.SCHEMA_ID) AS TABLE_SCHEMA,
  O.NAME AS TABLE_NAME,
  EP.VALUE AS REMARKS
FROM
  SYS.ALL_OBJECTS O
  INNER JOIN SYS.EXTENDED_PROPERTIES EP
    ON O.OBJECT_ID = EP.MAJOR_ID AND EP.MINOR_ID = 0
WHERE
  O.IS_MS_SHIPPED != 1
  AND O.TYPE = 'U'
  AND EP.MINOR_ID = 0
  AND EP.NAME = 'MS_Description'
