# SchemaCrawler Support and Consulting

## Supported Versions

Only the latest version of SchemaCrawler (v16.19.11) is supported from the point of new feature development and security updates. 
If you would like support for an older version of SchemaCrawler, please request a Professional Support Package. 
You can report a security vulnerability by filing an issue on the [SchemaCrawler issues page].

If you download and use SchemaCrawler, you are implicitly agreeing to the SchemaCrawler [licensing terms]. Please review
these [licensing terms].


## Levels of Support

There are various support channels available if you are having trouble using SchemaCrawler, think you may have found a bug, or want advice with using SchemaCrawler in your project.

**Professional Support Packages** provide you with direct access to the author of 
SchemaCrawler, to help you with advice with using SchemaCrawler in your project, and for consulting assignments for implementation. 
Custom licensing terms for commercial use can be arranged if needed.
Please contact Sualeh Fatehi <sualeh@hotmail.com> for details on a Professional Support Package to suit your needs.

**Community Support** is available on [Stack Overflow]. Helpful SchemaCrawler users, 
including the developer of SchemaCrawler, read messages on Stack Overflow. Please read *Guidelines for Support* below.

**Bug, Security Vulnerability and Issue Reports** can be filed on the [SchemaCrawler issues page]. 
Please do not ask questions on the issues page - instead, ask questions on 
[Stack Overflow]. Please read *Guidelines for Support* below.



## Guidelines for Support

Some guidelines for a quick response on [Stack Overflow] and the [SchemaCrawler discussions page]:

- Please explain the issue briefly, and specify the versions of SchemaCrawler, Java, 
  operating system, database, and JDBC driver that you are using
- Provide the steps that you took to reproduce the issue, and any steps that you took to 
  solve the issue
- Zip and attach the SchemaCrawler debug logs, which can be obtained by running 
  SchemaCrawler with an additional `--log-level=ALL` command-line argument


[Stack Overflow]: https://stackoverflow.com/search?q=schemacrawler+is%3Aquestion
[SchemaCrawler discussions page]: https://github.com/schemacrawler/SchemaCrawler/discussions
[SchemaCrawler issues page]: https://github.com/schemacrawler/SchemaCrawler/issues
[licensing terms]: license.html
